TriggersApi
Event Triggers provide real-time updates to changes in Identity Security Cloud so you can take action as soon as an event occurs, rather than poll an API endpoint for updates. Identity Security Cloud provides a user interface within the admin console to create and manage trigger subscriptions. These endpoints allow for programatically creating and managing trigger subscriptions.
There are two types of event triggers:
- `FIRE_AND_FORGET`: This trigger type will send a payload to each subscriber without needing a response. Each trigger of this type has a limit of 50 subscriptions.
- `REQUEST_RESPONSE`: This trigger type will send a payload to a subscriber and expect a response back. Each trigger of this type may only have one subscription.
Available Event Triggers
Production ready event triggers that are available in all tenants.
| Name | ID | Type | Trigger condition |
|---|---|---|---|
| Access Request Dynamic Approval | idn:access-request-dynamic-approver | REQUEST_RESPONSE | After an access request is submitted. Expects the subscriber to respond with the ID of an identity or workgroup to add to the approval workflow. |
| Access Request Decision | idn:access-request-post-approval | FIRE_AND_FORGET | After an access request is approved. |
| Access Request Submitted | idn:access-request-pre-approval | REQUEST_RESPONSE | After an access request is submitted. Expects the subscriber to respond with an approval decision. |
| Account Aggregation Completed | idn:account-aggregation-completed | FIRE_AND_FORGET | After an account aggregation completed, terminated, failed. |
| Account Attributes Changed | idn:account-attributes-changed | FIRE_AND_FORGET | After an account aggregation, and one or more account attributes have changed. |
| Account Correlated | idn:account-correlated | FIRE_AND_FORGET | After an account is added to an identity. |
| Accounts Collected for Aggregation | idn:aggregation-accounts-collected | FIRE_AND_FORGET | New, changed, and deleted accounts have been gathered during an aggregation and are being processed. |
| Campaign Activated | idn:campaign-activated | FIRE_AND_FORGET | After a campaign is activated. |
| Campaign Ended | idn:campaign-ended | FIRE_AND_FORGET | After a campaign ends. |
| Campaign Generated | idn:campaign-generated | FIRE_AND_FORGET | After a campaign finishes generating. |
| Certification Signed Off | idn:certification-signed-off | FIRE_AND_FORGET | After a certification is signed off by its reviewer. |
| Identity Attributes Changed | idn:identity-attributes-changed | FIRE_AND_FORGET | After One or more identity attributes changed. |
| Identity Created | idn:identity-created | FIRE_AND_FORGET | After an identity is created. |
| Provisioning Action Completed | idn:post-provisioning | FIRE_AND_FORGET | After a provisioning action completed on a source. |
| Scheduled Search | idn:saved-search-complete | FIRE_AND_FORGET | After a scheduled search completed. |
| Source Created | idn:source-created | FIRE_AND_FORGET | After a source is created. |
| Source Deleted | idn:source-deleted | FIRE_AND_FORGET | After a source is deleted. |
| Source Updated | idn:source-updated | FIRE_AND_FORGET | After configuration changes have been made to a source. |
| VA Cluster Status Change | idn:va-cluster-status-change | FIRE_AND_FORGET | After the status of a VA cluster has changed. |
All URIs are relative to https://sailpoint.api.identitynow.com
| Method | HTTP request | Description |
|---|---|---|
| complete-trigger-invocation-v1 | POST /trigger-invocations/v1/{id}/complete | Complete trigger invocation |
| create-subscription-v1 | POST /trigger-subscriptions/v1 | Create a subscription |
| delete-subscription-v1 | DELETE /trigger-subscriptions/v1/{id} | Delete a subscription |
| list-subscriptions-v1 | GET /trigger-subscriptions/v1 | List subscriptions |
| list-trigger-invocation-status-v1 | GET /trigger-invocations/v1/status | List latest invocation statuses |
| list-triggers-v1 | GET /triggers/v1 | List triggers |
| patch-subscription-v1 | PATCH /trigger-subscriptions/v1/{id} | Patch a subscription |
| start-test-trigger-invocation-v1 | POST /trigger-invocations/v1/test | Start a test invocation |
| test-subscription-filter-v1 | POST /trigger-subscriptions/v1/validate-filter | Validate a subscription filter |
| update-subscription-v1 | PUT /trigger-subscriptions/v1/{id} | Update a subscription |
complete-trigger-invocation-v1
Complete trigger invocation Completes an invocation to a REQUEST_RESPONSE type trigger.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| id | string | The ID of the invocation to complete. | [default to undefined] |
| completeinvocation | Completeinvocation |
Return type
(empty response body)
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { Completeinvocation } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const id: string = 0f11f2a4-7c94-4bf3-a2bd-742580fe3bde; // The ID of the invocation to complete.
const completeinvocation: Completeinvocation = {"secret":"0f11f2a4-7c94-4bf3-a2bd-742580fe3bde","output":{"approved":false}}; //
const result = await apiInstance.completeTriggerInvocationV1({ id: id, completeinvocation: completeinvocation });
console.log(result);
create-subscription-v1
Create a subscription This API creates a new subscription to a trigger and defines trigger invocation details. The type of subscription determines which config object is required:
- HTTP subscriptions require httpConfig
- EventBridge subscriptions require eventBridgeConfig
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| subscriptionpostrequest | Subscriptionpostrequest |
Return type
Subscription
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { Subscriptionpostrequest } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const subscriptionpostrequest: Subscriptionpostrequest = {"name":"Access request subscription","description":"Access requested to site xyz","triggerId":"idn:access-requested","type":"HTTP","httpConfig":{"url":"https://www.example.com","httpDispatchMode":"SYNC","httpAuthenticationType":"BASIC_AUTH","basicAuthConfig":{"userName":"user@example.com","password":"eRtg4%6yuI!"}},"enabled":true,"filter":"$[?($.identityId == \"201327fda1c44704ac01181e963d463c\")]"}; //
const result = await apiInstance.createSubscriptionV1({ subscriptionpostrequest: subscriptionpostrequest });
console.log(result);
delete-subscription-v1
Delete a subscription Deletes an existing subscription to a trigger.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| id | string | Subscription ID | [default to undefined] |
Return type
(empty response body)
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const id: string = 0f11f2a4-7c94-4bf3-a2bd-742580fe3bde; // Subscription ID
const result = await apiInstance.deleteSubscriptionV1({ id: id });
console.log(result);
list-subscriptions-v1
List subscriptions Gets a list of all trigger subscriptions.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| limit | number | Max number of results to return. See V3 API Standard Collection Parameters for more information. | [optional] [default to 250] |
| offset | number | Offset into the full result set. Usually specified with limit to paginate through the results. See V3 API Standard Collection Parameters for more information. | [optional] [default to 0] |
| count | boolean | If true it will populate the X-Total-Count response header with the number of results that would be returned if limit and offset were ignored. Since requesting a total count can have a performance impact, it is recommended not to send count=true if that value will not be used. See V3 API Standard Collection Parameters for more information. | [optional] [default to false] |
| filters | string | Filter results using the standard syntax described in V3 API Standard Collection Parameters Filtering is supported for the following fields and operators: id: eq triggerId: eq type: eq, le | [optional] [default to undefined] |
| sorters | string | Sort results using the standard syntax described in V3 API Standard Collection Parameters Sorting is supported for the following fields: triggerId, triggerName | [optional] [default to undefined] |
Return type
Array<Subscription>
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const limit: number = 250; // Max number of results to return. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const offset: number = 0; // Offset into the full result set. Usually specified with *limit* to paginate through the results. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const count: boolean = true; // If *true* it will populate the *X-Total-Count* response header with the number of results that would be returned if *limit* and *offset* were ignored. Since requesting a total count can have a performance impact, it is recommended not to send **count=true** if that value will not be used. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const filters: string = id eq "12cff757-c0c0-413b-8ad7-2a47956d1e89"; // Filter results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#filtering-results) Filtering is supported for the following fields and operators: **id**: *eq* **triggerId**: *eq* **type**: *eq, le* (optional)
const sorters: string = triggerName; // Sort results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#sorting-results) Sorting is supported for the following fields: **triggerId, triggerName** (optional)
const result = await apiInstance.listSubscriptionsV1({ });
console.log(result);
list-trigger-invocation-status-v1
List latest invocation statuses Gets a list of latest invocation statuses. Statuses of successful invocations are available for up to 24 hours. Statuses of failed invocations are available for up to 48 hours. This endpoint may only fetch up to 2000 invocations, and should not be treated as a representation of the full history of invocations.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| limit | number | Max number of results to return. See V3 API Standard Collection Parameters for more information. | [optional] [default to 250] |
| offset | number | Offset into the full result set. Usually specified with limit to paginate through the results. See V3 API Standard Collection Parameters for more information. | [optional] [default to 0] |
| count | boolean | If true it will populate the X-Total-Count response header with the number of results that would be returned if limit and offset were ignored. Since requesting a total count can have a performance impact, it is recommended not to send count=true if that value will not be used. See V3 API Standard Collection Parameters for more information. | [optional] [default to false] |
| filters | string | Filter results using the standard syntax described in V3 API Standard Collection Parameters Filtering is supported for the following fields and operators: triggerId: eq subscriptionId: eq | [optional] [default to undefined] |
| sorters | string | Sort results using the standard syntax described in V3 API Standard Collection Parameters Sorting is supported for the following fields: triggerId, subscriptionName, created, completed | [optional] [default to undefined] |
Return type
Array<Invocationstatus>
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const limit: number = 250; // Max number of results to return. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const offset: number = 0; // Offset into the full result set. Usually specified with *limit* to paginate through the results. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const count: boolean = true; // If *true* it will populate the *X-Total-Count* response header with the number of results that would be returned if *limit* and *offset* were ignored. Since requesting a total count can have a performance impact, it is recommended not to send **count=true** if that value will not be used. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const filters: string = triggerId eq "idn:access-request-dynamic-approver"; // Filter results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#filtering-results) Filtering is supported for the following fields and operators: **triggerId**: *eq* **subscriptionId**: *eq* (optional)
const sorters: string = created; // Sort results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#sorting-results) Sorting is supported for the following fields: **triggerId, subscriptionName, created, completed** (optional)
const result = await apiInstance.listTriggerInvocationStatusV1({ });
console.log(result);
list-triggers-v1
List triggers Gets a list of triggers that are available in the tenant.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| limit | number | Max number of results to return. See V3 API Standard Collection Parameters for more information. | [optional] [default to 250] |
| offset | number | Offset into the full result set. Usually specified with limit to paginate through the results. See V3 API Standard Collection Parameters for more information. | [optional] [default to 0] |
| count | boolean | If true it will populate the X-Total-Count response header with the number of results that would be returned if limit and offset were ignored. Since requesting a total count can have a performance impact, it is recommended not to send count=true if that value will not be used. See V3 API Standard Collection Parameters for more information. | [optional] [default to false] |
| filters | string | Filter results using the standard syntax described in V3 API Standard Collection Parameters Filtering is supported for the following fields and operators: id: eq, ge, le | [optional] [default to undefined] |
| sorters | string | Sort results using the standard syntax described in V3 API Standard Collection Parameters Sorting is supported for the following fields: id, name | [optional] [default to undefined] |
Return type
Array<Trigger>
HTTP request headers
- Content-Type: Not defined
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const limit: number = 250; // Max number of results to return. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const offset: number = 0; // Offset into the full result set. Usually specified with *limit* to paginate through the results. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const count: boolean = true; // If *true* it will populate the *X-Total-Count* response header with the number of results that would be returned if *limit* and *offset* were ignored. Since requesting a total count can have a performance impact, it is recommended not to send **count=true** if that value will not be used. See [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters) for more information. (optional)
const filters: string = id eq "idn:access-request-post-approval"; // Filter results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#filtering-results) Filtering is supported for the following fields and operators: **id**: *eq, ge, le* (optional)
const sorters: string = name; // Sort results using the standard syntax described in [V3 API Standard Collection Parameters](https://developer.sailpoint.com/idn/api/standard-collection-parameters#sorting-results) Sorting is supported for the following fields: **id, name** (optional)
const result = await apiInstance.listTriggersV1({ });
console.log(result);
patch-subscription-v1
Patch a subscription This API updates a trigger subscription in IdentityNow, using a set of instructions to modify a subscription partially. The following fields are patchable:
name, description, enabled, type, filter, responseDeadline, httpConfig, eventBridgeConfig, workflowConfig
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| id | string | ID of the Subscription to patch | [default to undefined] |
| subscriptionpatchrequestInner | Array<SubscriptionpatchrequestInner> |
Return type
Subscription
HTTP request headers
- Content-Type: application/json-patch+json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { SubscriptionpatchrequestInner } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const id: string = 0f11f2a4-7c94-4bf3-a2bd-742580fe3bde; // ID of the Subscription to patch
const subscriptionpatchrequestInner: Array<SubscriptionpatchrequestInner> = ; //
const result = await apiInstance.patchSubscriptionV1({ id: id, subscriptionpatchrequestInner: subscriptionpatchrequestInner });
console.log(result);
start-test-trigger-invocation-v1
Start a test invocation Initiate a test event for all subscribers of the specified event trigger. If there are no subscribers to the specified trigger in the tenant, then no test event will be sent.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| testinvocation | Testinvocation |
Return type
Array<Invocation>
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { Testinvocation } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const testinvocation: Testinvocation = {"triggerId":"idn:access-requested","input":{"identityId":"201327fda1c44704ac01181e963d463c"},"contentJson":{"workflowId":1234}}; //
const result = await apiInstance.startTestTriggerInvocationV1({ testinvocation: testinvocation });
console.log(result);
test-subscription-filter-v1
Validate a subscription filter Validates a JSONPath filter expression against a provided mock input. Request requires a security scope of:
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| validatefilterinputdto | Validatefilterinputdto |
Return type
Validatefilteroutputdto
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { Validatefilterinputdto } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const validatefilterinputdto: Validatefilterinputdto = {"input":{"identityId":"201327fda1c44704ac01181e963d463c"},"filter":"$[?($.identityId == \"201327fda1c44704ac01181e963d463c\")]"}; //
const result = await apiInstance.testSubscriptionFilterV1({ validatefilterinputdto: validatefilterinputdto });
console.log(result);
update-subscription-v1
Update a subscription This API updates a trigger subscription in IdentityNow, using a full object representation. In other words, the existing Subscription is completely replaced. The following fields are immutable:
-
id
-
triggerId
Attempts to modify these fields result in 400.
Parameters
| Name | Type | Description | Notes |
|---|---|---|---|
| id | string | Subscription ID | [default to undefined] |
| subscriptionputrequest | Subscriptionputrequest |
Return type
Subscription
HTTP request headers
- Content-Type: application/json
- Accept: application/json
Example
import { TriggersApi } from 'sailpoint-api-client';
import { Configuration } from 'sailpoint-api-client';
import { Subscriptionputrequest } from 'sailpoint-api-client/dist/triggers/api';
const configuration = new Configuration();
const apiInstance = new TriggersApi(configuration);
const id: string = 0f11f2a4-7c94-4bf3-a2bd-742580fe3bde; // Subscription ID
const subscriptionputrequest: Subscriptionputrequest = {"name":"Access request subscription","description":"Access requested to site xyz","type":"HTTP","httpConfig":{"url":"https://www.example.com","httpDispatchMode":"SYNC","httpAuthenticationType":"BASIC_AUTH","basicAuthConfig":{"userName":"user@example.com","password":"eRtg4%6yuI!"}},"enabled":true,"filter":"$[?($.identityId == \"201327fda1c44704ac01181e963d463c\")]"}; //
const result = await apiInstance.updateSubscriptionV1({ id: id, subscriptionputrequest: subscriptionputrequest });
console.log(result);